import type { Device } from "@siteimprove/alfa-device";
import { type Element } from "@siteimprove/alfa-dom";
import { Rectangle } from "@siteimprove/alfa-rectangle";
import { Option } from "@siteimprove/alfa-option";
/**
 * Gets the bounding box of the clickable area of an element
 * or None if the element or one of its descendants doesn't have a bounding box.
 *
 * @remarks
 * This function assumes that the element can receive pointer events, i.e. is clickable.
 * If called on an element that is not clickable, the function will still return the
 * the area that would be clickable if the element could receive pointer events.
 *
 * @internal
 */
export declare function getClickableBox(device: Device, element: Element): Option<Rectangle>;
//# sourceMappingURL=get-clickable-box.d.ts.map