import { Diagnostic, Rule } from "@siteimprove/alfa-act";
import { Element, Node, Text } from "@siteimprove/alfa-dom";
import type { Hash } from "@siteimprove/alfa-hash";
import { Option } from "@siteimprove/alfa-option";
import { Err, Ok } from "@siteimprove/alfa-result";
import type { Page } from "@siteimprove/alfa-web";
declare const _default: Rule.Atomic<Page, Text, {}, Text>;
export default _default;
/**
 * @public
 */
export declare class ClippingAncestors extends Diagnostic {
    static of(message: string, horizontal?: Option<Element>, vertical?: Option<Element>): ClippingAncestors;
    private readonly _horizontal;
    private readonly _vertical;
    private constructor();
    get horizontal(): Option<Element>;
    get vertical(): Option<Element>;
    equals(value: ClippingAncestors): boolean;
    equals(value: unknown): value is this;
    hash(hash: Hash): void;
    toJSON(options?: Node.SerializationOptions): ClippingAncestors.JSON;
}
/**
 * @public
 */
export declare namespace ClippingAncestors {
    interface JSON extends Diagnostic.JSON {
        horizontal: Option.JSON<Element>;
        vertical: Option.JSON<Element>;
    }
    function isClippingAncestors(value: Diagnostic): value is ClippingAncestors;
    function isClippingAncestors(value: unknown): value is ClippingAncestors;
}
/**
 * @public
 */
export declare namespace Outcomes {
    const WrapsText: Ok<ClippingAncestors>;
    const ClipsText: (horizontal: Option<Element>, vertical: Option<Element>) => Err<ClippingAncestors>;
    const IsContainer: (horizontal: Option<Element>, vertical: Option<Element>) => Ok<ClippingAncestors>;
}
//# sourceMappingURL=rule.d.ts.map