import { Tag } from "@siteimprove/alfa-act";
/**
 * @public
 */
export declare class Stability<S extends string = string> extends Tag<"stability"> {
    static of<S extends string>(stability: S): Stability<S>;
    private readonly _stability;
    private constructor();
    get type(): "stability";
    get stability(): S;
    equals(value: Stability): boolean;
    equals(value: unknown): value is this;
    toJSON(): Stability.JSON<S>;
}
/**
 * @public
 */
export declare namespace Stability {
    interface JSON<S extends string = string> extends Tag.JSON<"stability"> {
        stability: S;
    }
    /**
     * For experimental rules. These rules are not necessarily compatible with
     * downstream data processing, and are subject to breaking changes without
     * notice
     */
    const Experimental: Stability<"experimental">;
    /**
     * For stable rules. These rules follow the same basic principles and are
     * reasonably stable; their changes are tracked by normal semver numbering.
     */
    const Stable: Stability<"stable">;
    /**
     * For deprecated rules. These rules are deprecated and will be removed
     * permanently after some grace period.
     */
    const Deprecated: Stability<"deprecated">;
}
//# sourceMappingURL=stability.d.ts.map