import { Tag } from "@siteimprove/alfa-act";
/**
 * @public
 */
export declare class Version<N extends number = number> extends Tag<"version"> {
    static of<N extends number>(version: N): Version<N>;
    private readonly _version;
    private constructor();
    get type(): "version";
    get version(): N;
    equals(value: Version): boolean;
    equals(value: unknown): value is this;
    toJSON(): Version.JSON<N>;
}
/**
 * @public
 */
export declare namespace Version {
    interface JSON<N extends number = number> extends Tag.JSON<"version"> {
        version: N;
    }
    function isVersion<T extends string>(value: unknown): value is Version;
}
//# sourceMappingURL=version.d.ts.map